#include <stdio.h>
#include <stdlib.h>

#define A 0
#define B 1

int n, m, k, conn[2][5001]={ {0}, {0} }, odd[5001][2];
int erased[2][5000], erasedNum=0;
int link[5001][2];

void end_no( void );
void eraseLink( int a, int b );


int main()
{
   int i, j;
   scanf("%d%d%d", &m, &n, &k);

   for(i=0;i<5001;i++) odd[i][0]=odd[i][1]=0;

   for(i=1;i<=k;i++)
   {
      scanf("%d%d", &link[i][A], &link[i][B]);
      conn[ A ][ link[i][A] ]++;
      conn[ B ][ link[i][B] ]++;
   }
   if(k<(m*2)) end_no();
   if( (m*2) < n ) end_no();


   for(i=1;i<=m;i++)
      if( conn[A][i] < 2 ) end_no();
     else odd[i][A]=conn[A][i]-2;
      

   for(i=1;i<=n;i++)
     if( conn[B][i] > 1 ) odd[i][B] = conn[B][i]-1;
     else odd[i][B]=0;


   for(i=1;i<=m;i++)
   {
      while(odd[i][A])
      {
         int flag=0;
         for(j=1;j<=n;j++)
           if( odd[j][B] ){ eraseLink( i, j ); flag=1; break; }

         if(!flag)
         {
           for(j=1;j<=n;j++)
            if( link[j][A] == i ){ eraseLink(i, link[j][B]); break; }
         }
      }
   }
   for(i=1;i<=n;i++) if(odd[i][B]) end_no();

   printf("%d\n", erasedNum);
   for(i=0;i<erasedNum;i++) printf("%d %d\n", erased[A][i], erased[B][i]);

   return 0;

}


void end_no( void )
{
    printf("NO\n");
    exit( EXIT_SUCCESS );
}

void eraseLink( int a, int b )
{
   int i, flag=0;
      for(i=1;i<=k;i++)
         if( ( link[i][A] == a) && (link[i][B] == b ) )
         {
             link[i][A] = link[i][B] = 0;
             flag=1;
             break;
         }

   if(!flag) return ;


   conn[A][ a ]--;
   conn[B][ b ]--;


   odd[a][A]--;
   if( odd[b][B] ) odd[b][B]--;

   erased[A][erasedNum] = a;
   erased[B][erasedNum] = b;

   erasedNum++;

   return ;
}
